(*
 * Copyright 2015-2016 IBM Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *)

(* Result checking *)

open ConfigUtil
open Compiler.EnhancedCompiler

(* Check result *)

val print_nraenv_result : string -> QData.data option -> unit
val check_nraenv_result : eval_config -> QData.data list -> string -> QData.data option -> string -> unit

val print_rule_result : string -> QData.data option -> unit
val print_oql_result : string -> QData.data option -> unit

val validate_result : QData.data list -> QData.data option -> unit
    
val check_rule_result : eval_config -> QData.data list -> string -> QData.data option -> string -> unit
val check_oql_result : QData.data list -> string -> QData.data option -> string -> unit

